package com.jmu.shiro_demo.controller;


import com.jmu.shiro_demo.service.UserService;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.authc.UsernamePasswordToken;
import org.apache.shiro.mgt.SecurityManager;
import org.apache.shiro.subject.Subject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author ${author}
 * @since 2021-04-20
 */
@Controller
@RequestMapping("/user")
public class UserController {

    @Autowired
    private UserService userService;

    @GetMapping("/add")
    public String toUserAdd(){
        return "user/add";
    }

    @GetMapping("/update")
    public String toUserUpdate(){
        return "user/update";
    }

    @GetMapping("/delete")
    public String toUserDelete(){
        return "user/delete";
    }

    @PostMapping("/login")
    @ResponseBody
    public Map<String,String> login(String username, String password, String code,
                     HttpSession session, HttpServletResponse response, Model model) {
        Map<String,String> map = new HashMap<String, String>();
        map.put("url",userService.login(username,password,code,session,response,model));
        map.put("token",response.getHeader("token"));
        return map;
    }

}
