package com.jmu.shiro_demo;

import com.auth0.jwt.JWT;
import com.auth0.jwt.JWTVerifier;
import com.auth0.jwt.algorithms.Algorithm;
import com.auth0.jwt.interfaces.DecodedJWT;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

class ShiroDemoApplicationTests {

    private final String SIGN = "jiachengren";

    @Test
    void contextLoads() {
        Map<String,Object> map = new HashMap<String, Object>();
        Calendar instance = Calendar.getInstance();
        instance.add(Calendar.SECOND,0);
        String token = JWT.create()
                .withHeader(map)
                .withClaim("userId", 12)
                .withClaim("username", "1")
                .withExpiresAt(instance.getTime())
                .sign(Algorithm.HMAC256(SIGN));
        System.out.println(token);
        test(token);
    }

    @Test
    void test(String token) {
        JWTVerifier jwtVerifier = JWT.require(Algorithm.HMAC256(SIGN)).build();
        DecodedJWT decodedJWT = jwtVerifier.verify(token);
        System.out.println(decodedJWT.getClaim("userId").asInt());
        System.out.println(decodedJWT.getClaim("username").asString());
    }

}
